<template>
  <div v-loading="loading">
    <CDataTable
      :items="data"
      :fields="FIELDS"
    >
      <template #name="{item,index}">
        <td>
          <font-awesome-icon :icon="['fas', `angle-${details.includes(index) ? 'down' : 'up'}`]" class="width-1x" />
          <CLink
            variant="ghost"
            square
            @click="toggleDetails(index)"
          >
            {{ item.name }}
          </CLink>
        </td>
      </template>

      <template #details="{item, index}">
        <CCollapse :show="!details.includes(index)">
          <div>
            Filters:
          </div>
          <CDataTable
            hover
            :items="item.groups"
            :fields="COMMON_FIELDS"
            class="table-wrapper"
          >
            <template #status="{item}">
              <td>
                <span :class="`badge badge-${item.status === 1 ? 'success' : 'danger'}`">
                  {{ item.status === 1 ? 'ON' : 'OFF' }}
                </span>
              </td>
            </template>

            <template #control="{item}">
              <td>
                <app-control-button
                  :id="item.id"
                  :color="COLOR_SUCCESS_CONTROL_BUTTON"
                  :variant="VARIANT_CONTROL_BUTTON"
                  :control-label="'On all'"
                  @set-control="onControl"
                />

                <app-control-button
                  :id="item.id"
                  :color="COLOR_DANGER_CONTROL_BUTTON"
                  :variant="VARIANT_CONTROL_BUTTON"
                  :control-label="'Off all'"
                  @set-control="offControl"
                />
              </td>
            </template>

            <template #action="{ item }">
              <td class="white-space-nowrap">
                <CButton size="sm" color="primary" @click="onShowDetail(item.id)">
                  <font-awesome-icon :icon="['fas', 'pencil-alt']" />
                </CButton>
                &nbsp;
                <CButton size="sm" color="danger" @click="onDelete(item.id)">
                  <font-awesome-icon :icon="['fas', 'trash-alt']" />
                </CButton>
              </td>
            </template>
          </CDataTable>
        </CCollapse>
      </template>
    </CDataTable>
  </div>
</template>

<style lang="scss" scoped>
  .table-wrapper {
    /deep/ {
      width: 100%;
      border-bottom: 1px solid #d8dbe0;
      margin-bottom: 0;
      thead {
          tr {
            th {
              text-align: center;
            }
          }
        }
      & td{
        padding: 0 12px;
        vertical-align: 0;
        text-align: center;
      }
    }
  }

</style>

<script>
import AppControlButton from '~/components/atoms/AppControlButton'

export const ZONE_TABLE_HEADER_OPTION = [
  { key: 'name', label: 'Zone' }
]

export const GROUP_TABLE_HEADER = [
  { key: 'name' },
  { key: 'description' },
  { key: 'status' },
  { key: 'control', sorter: false },
  { key: 'action', label: 'Action', sorter: false }
]
const EVENT_DELETE = 'delete'
const EVENT_SHOW_DETAIL = 'show-detail'
const EVENT_ON_CONTROL = 'on-control'
const EVENT_OFF_CONTROL = 'off-control'
const COLOR_SUCCESS_CONTROL_BUTTON = 'success'
const COLOR_DANGER_CONTROL_BUTTON = 'danger'
const VARIANT_CONTROL_BUTTON = 'ghost'

export default {
  components: {
    AppControlButton
  },

  props: {
    /**
     * User list
     */
    data: {
      type: Array,
      default: () => []
    },

    /**
     * Loading status
     */
    loading: {
      type: Boolean,
      default: false
    }
  },

  data () {
    return {
      editZone: false,
      details: [],
      groupItem: [],
      COLOR_SUCCESS_CONTROL_BUTTON,
      COLOR_DANGER_CONTROL_BUTTON,
      VARIANT_CONTROL_BUTTON
    }
  },

  computed: {
    /**
     * Get FIELDS of header table
     *
     * @return {array} FIELDS of header table
     */
    FIELDS () {
      return ZONE_TABLE_HEADER_OPTION
    },

    /**
     * Get FIELDS of header table
     *
     * @return {array} FIELDS of header table
     */
    COMMON_FIELDS () {
      return GROUP_TABLE_HEADER
    }
  },

  methods: {
    /**
     * Show hide group table
     *
     * @param {Number} index - Index of array groups
     */
    toggleDetails (index) {
      const position = this.details.indexOf(index)
      position !== -1 ? this.details.splice(position, 1) : this.details.push(index)
    },

    /**
     * Event show user detail modal
     *
     * @param {string} user - User
     */
    onShowDetail (id) {
      this.$emit(EVENT_SHOW_DETAIL, id)
    },

    /**
     * Delete user
     *
     * @param {string} id - User id
     */
    onDelete (id) {
      this.$emit(EVENT_DELETE, id)
    },

    /**
     * emit
     *
     * @param {string} id - User id
     */
    onControl (id) {
      this.$emit(EVENT_ON_CONTROL, id, this.isOn)
    },

    /**
     * Delete user
     *
     * @param {string} id - User id
     */
    offControl (id) {
      this.$emit(EVENT_OFF_CONTROL, id)
    }
  }
}
</script>
